################################################################################################################
# HTML5                                     :   https://html5up.net/
# Stop and RM all containers                :   docker stop $(docker ps -a -q) && docker rm $(docker ps -a -q)
# Purge all Docker containers and network   :   docker system prune -a && docker images purge
# Build and launch containers               :   docker-compose build --no-cache && docker-compose up --build -d
# Light sensor                              :   http://www.uugear.com/product/uugear-light-sensor-module-4-wire-with-both-digital-and-analog-output/
# Ngixn +  Flask                            :   https://www.digitalocean.com/community/tutorials/how-to-serve-flask-applications-with-uswgi-and-nginx-on-ubuntu-18-04
# Fan control								:	https://blog.codybunch.com/2017/07/14/Docker-on-Raspberry-PI-for-Fan-Control/
# Docker Flask & Nginx reverse proxy        :   https://dev.to/ishankhare07/nginx-as-reverse-proxy-for-a-flask-app-using-docker-3ajg
# Python websocketIo                        :   https://flask-socketio.readthedocs.io/en/latest/
# Encodage                                  :   http://sametmax.com/lencoding-en-python-une-bonne-fois-pour-toute/
# For slow conection, please set these below
# sudo service docker stop
# sudo dockerd --max-concurrent-downloads 1
# sudo dockerd --max-concurrent-uploads 1
# sudo service docker start
################################################################################################################
version: '3.2'
services:
  ##############################################################################################################
  # Python container
  # Python enum       :   http://techspot.zzzeek.org/2011/01/14/the-enum-recipe/
  #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  # Shell             :   docker exec -ti python /bin/sh
  #                       docker exec -ti python bash
  ##############################################################################################################
  python:
    container_name: python
    build:
      context: python
      dockerfile: Dockerfile
    ports:
      - "5000:5000"
    volumes:
      - ./app:/opt/services/flaskapp/src
      - ./logs:/var/log/supervisor
    env_file:
      - ./app/.env
    privileged: true
    devices:
      - /dev/gpiomem:/dev/gpiomem
    restart: always
    networks:
      - db_network
      - web_network
    depends_on:
      - postgresql
    dns:
      - 208.67.222.222
      - 208.67.220.220
  ##############################################################################################################
  # Nginx container
  #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  # Shell             :   docker exec -ti nginx /bin/sh
  #                       docker exec -ti nginx bash
  ##############################################################################################################
  nginx:
    container_name: nginx
    build:
      context: nginx
      dockerfile: Dockerfile
    ports:
      - "80:80"
    volumes:
      - ./nginx/conf.d/flaskapp.conf:/etc/nginx/conf.d/default.conf
      - ./logs:/var/log/nginx/
    restart: always
    tty: true
    networks:
      - web_network
    depends_on:
      - python
  ##############################################################################################################
  # PostgreSQL container
  #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  # Shell             :   docker exec -ti postgresql /bin/sh
  #                       docker exec -ti postgresql bash
  #						  docker exec -ti postgresql psql -d flaskapp_db -U postgres
  # Usefull queries   :   TRUNCATE TABLE table_name RESTART IDENTITY;
  ##############################################################################################################
  postgresql:
    container_name: postgresql
    #build:
    #  context: postgresql
    #  dockerfile: Dockerfile
    image: postgres:10.4-alpine
    ports:
      - "5432:5432"
    volumes:
      - ./postgresql:/var/lib/postgresql/data
      - ./logs:/var/log/postgresql
    env_file:
      - ./app/.env
    restart: always
    networks:
      - db_network
  ##############################################################################################################
  # Adminer container
  #~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
  # Shell             :   docker exec -ti adminer /bin/sh
  #                       docker exec -ti adminer bash
  # Web UX            :   http://ip_address:8081
  ##############################################################################################################
  #adminer:
  #  container_name: adminer
  #  image: adminer:4.7.5-standalone
  #  restart: always
  #  ports:
  #    - "8080:8080"
  #  restart: always
  #  networks:
  #    - db_network

networks:
  db_network:
    driver: bridge
  web_network:
    driver: bridge
